<%@ page import="com.ether.WebHelper" %>
<%@ taglib prefix="spring" uri="http://www.springframework.org/tags" %>

<script type="text/javascript">

var InterfaceStatistics = Class.create( {
    initialize: function()
    {
        /** *********** CONTAINERS *********** **/
        this.parent = $( "#containerMiddle" );
        this.containerMenu = $( "#menuCircle" );
        this.containerErrors = $( "#errors" );

        /** *********** VARIABLES *********** **/
        this.language = '<spring:message code="language"/>';
        this.webmaster = "<%=WebHelper.getProperty(request, "mail.webmaster")%>";
        this.projectsPath = "resources/images/";
        this.projectsArray = [
            {id:"ETHER", img:"logo_Ether_50.jpg", top:"-16px", left:"125px"},
            {id:"NDACC", img:"logo_Ndacc_50.jpg", top:"1.66667px", left:"46.3334px"},
            {id:"ECCAD", img:"logo_ECCAD_50.gif", top:"39.3333px", left:"109.333px"},
            {id:"IASI", img:"logo_iasi_50.jpg", top:"-78.6667px", left:"77.6666px"},
            {id:"GOSAT", img:"logo_gosat_50.jpg", top:"-0.333328px", left:"200.667px"},
            {id:"IAGOS", img:"logo_Iagos_50.jpg", top:"36px", left:"138px"},
            {id:"TROPICO", img:"logo_tropico_50.jpg", top:"-74px", left:"45px"},
            {id:"MEGAPOLI", img:"logo_Megapoli_50.png", top:"-74.3333px", left:"15.3333px"},
            {id:"MIMOSA", img:"logo_mimosa_50.png", top:"-45.6667px", left:"76.3334px"},
            {id:"REPROBUS", img:"logo_reprobus_50.png", top:"-48px", left:"161.667px"},
            {id:"GEISA", img:"logo_geisa_50.jpg", top:"22px", left:"167.667px"},
            {id:"TAPAS", img:"logo_tapas_50.png", top:"58.3333px", left:"125px"},
            {id:"OUTREACH", img:"logo_acomida_50.jpg", top:"-77.3333px", left:"225px"},
            {id:"OMER7A", img:"logo_omer7A_50.jpg", top:"22.6667px", left:"76.3334px"},
            {id:"GIRAFE", img:"logo_girafe_50.JPG", top:"-79.6667px", left:"192.333px"},
            {id:"ARLETTY", img:"logo_arletty_50.jpg", top:"-79px", left:"161.667px"}
        ];
        this.widthInitLogin = $( "#login_bg" ).width();
        this.widthInitMentionsOrCredits = $( "#mentions" ).width();

        this.xArray = ["2010-10", "2010-11", "2010-12", "2011-01", "2011-02"];
        this.yArray = [0, 10, 30, 50, 100];


        this.bindButtons();
        this.createDraggableSlides();
        this.createMenuCircle();

        $( document ).ready( jQuery.proxy( function()
        {
            $( ".containerToDrag" ).draggable();
            // Menu
            this.animateMenuCircle();
            this.bindMenuCircle();
            // Slides
//            this.onClickHelp();
            this.selectedLogo = $( "#ETHER" )[0];
            this.isSelectedLogoEther = true;
            this.onClickLogo();

            this.changeRightSlide();
        }, this ) );
    },


    // CREATES AND BINDS ********************************************************
    bindButtons: function()
    {
        $( "#home_button" ).bind( "dblclick", this.onClickHome );
        $( "#language_button" ).bind( "dblclick", jQuery.proxy( this.onClickLanguage, this ) );
        $( "#mail_button" ).bind( "dblclick", this.onClickMail );
        $( "#login_button" ).bind( "dblclick", jQuery.proxy( this.onClickLogin, this ) );
        $( "#help" ).bind( "click", jQuery.proxy( this.onClickHelp, this ) );
        $( "#credits" ).bind( "dblclick", jQuery.proxy( this.onClickCredits, this ) );
        $( "#mentions" ).bind( "dblclick", jQuery.proxy( this.onClickMentions, this ) );
    },

    createMenuCircle: function()
    {
        var menuSize = this.containerMenu.width();
        var nbLogosForSize = (this.projectsArray.length / 2) + 1;
        var divLogoSize = menuSize / nbLogosForSize;
        this.logoSize = divLogoSize - 5;

        var initTop = this.projectsArray[0].top;
        var initLeft = this.projectsArray[0].left;

        jQuery.each( this.projectsArray, jQuery.proxy( function( i, logo )
        {
            var divLogo = $( document.createElement( "div" ) );
            divLogo.addClass( "divLogo containerToDrag" );
            divLogo.attr( {id:logo.id, style:"position:absolute; top:" + initTop + "; left:" + initLeft} );
            divLogo.html( '<img id="img_' + logo.id + '"src="' + this.projectsPath + '' + logo.img + '" width="' + this.logoSize + 'px" height="' + this.logoSize + 'px"/>' );
            $( "#menuCircle" ).append( divLogo );
        }, this ) );
    },

    createDraggableSlides: function()
    {
        this.leftTopSlide = new DragSlide( {id:"leftTop", parent:this.parent, width:"170", height:"200", top:"140px", left:"53px",
            specificClass:"containerStatistics", specificTitleClass:"containerStatisticsTitle", specificContentClass:"containerStatisticsContent"} );

        this.leftMiddleSlide = new DragSlide( {id:"leftMiddleSlide", parent:this.parent, width:"170", height:"100", top:"355px", left:"53px",
            specificClass:"containerStatistics", specificTitleClass:"containerStatisticsTitle", specificContentClass:"containerStatisticsContent"} );
        this.leftMiddleSlide.setTitle( '<spring:message code="statistics.data"/>' );

        this.leftBottomSlide = new DragSlide( {id:"leftBottomSlide", parent:this.parent, width:"170", height:"100", top:"470px", left:"53px",
            specificClass:"containerStatistics", specificTitleClass:"containerStatisticsTitle", specificContentClass:"containerStatisticsContent"} );
        this.leftBottomSlide.setTitle( '<spring:message code="statistics.duration"/>' );

        this.middleSlide = new DragSlide( {id:"middle", parent:this.parent, width:"430", height:"430", top:"140px", left:"245px",
            specificClass:"containerStatistics", specificTitleClass:"containerStatisticsTitle", specificContentClass:"containerStatisticsContent"} );

        this.rightSlide = new DragSlide( {id:"right", parent:this.parent, width:"200", height:"300", top:"180px", left:"698px",
            specificClass:"containerStatistics", specificTitleClass:"containerStatisticsTitle", specificContentClass:"containerStatisticsContent"} );
    },

    // REQUESTS ********************************************************
    requestChangeLocale: function()
    {
        $.ajax( {
            url: "project?methodName=setLocale&language=<spring:message code="label.language.value.to.switch"/>",
            success:function()
            {
                location.reload();
            }
        } );
    },

    requestDataByLogo: function()
    {
        if( !this.selectedLogo && !this.selectedLogo.id )
            return;

        $.ajax( {
            url: "statistic?methodName=searchMainStatisticsByProject&name=" + this.selectedLogo.id,
            success:jQuery.proxy( this.handleDataByLogo, this ),
            error: jQuery.proxy( this.showErrors, [this] )
        } );
    },

    // HANDLES ******************************************************** = retours ajax
    handleDataByLogo: function( result )
    {
        this.changeLeftTopSlide();
        this.changeLeftMiddleSlide();
        this.changeLeftBottomSlide();
        this.displayVisitEvolution();
    },

    // EVENTS ********************************************************
    onClickHome: function()
    {
        location.reload();
    },

    onClickLanguage: function()
    {
        this.requestChangeLocale();
    },

    onClickMail: function()
    {
        document.location.href = "mailto:" + this.webmaster + "?subject=[STATISTICS]";
    },

    onClickLogin: function()
    {
        if( this.widthInitLogin == $( "#login_bg" ).width() )
            this.enlargeLogin();
        else
            this.reduceLogin();
    },

    onClickMentions: function()
    {
        if( this.widthInitMentionsOrCredits == $( "#mentions" ).width() )
            this.enlargeCreditsOrMentions( $( "#mentions" ), $( "#mentions_bg" ), $( "#mentions_text" ), $( "#mentions_title" ), "project/mentions_" + this.language + ".jsp" );
        else
            this.reduceCreditsOrMentions( $( "#mentions" ), $( "#mentions_bg" ), $( "#mentions_text" ), $( "#mentions_title" ), "project/mentions_" + this.language + ".jsp" );
    },

    onClickCredits: function()
    {
        if( this.widthInitMentionsOrCredits == $( "#credits" ).width() )
            this.enlargeCreditsOrMentions( $( "#credits" ), $( "#credits_bg" ), $( "#credits_text" ), $( "#credits_title" ), "project/credits_" + this.language + ".jsp" );
        else
            this.reduceCreditsOrMentions( $( "#credits" ), $( "#credits_bg" ), $( "#credits_text" ), $( "#credits_title" ), "project/credits_" + this.language + ".jsp" );
    },

    onClickHelp: function()
    {
        this.rightSlide.setTitle( '<spring:message code="label.help"/>' );
        this.rightSlide.setContent( "<spring:message code='label.help.content'/>" );
        var backHelpButton = new Button( {value:"<spring:message code="label.display.actions"/>", parent:this.rightSlide.getDivContent(), className: "small positive back_button", onClick:jQuery.proxy( this.changeRightSlide, this )} );
    },

    onClickButtonLogin: function()
    {
        // TODO reduce cloud

    },

    onClickLogo: function()
    {
        this.isSelectedLogoEther = (this.selectedLogo == $( "#ETHER" )[0]);
        this.requestDataByLogo();
    },

    onClickExport: function()
    {
        $( "#containerMiddle" ).printPreview();
//        $("#containerMiddle").jqprint();

//        var printContent =$( "#containerMiddle" );
//        var windowUrl = 'about:blank';
//        var windowName = 'Print';
//        var printWindow = window.open( windowUrl, windowName, 'left=50000,top=50000,width=0,height=0' );
//        printWindow.document.write( "slkdfjlsdkfjsdlf" );
//        printWindow.document.close();
//        printWindow.focus();
//        printWindow.print();
//        printWindow.close();
//
        // TODO export PDF
    },

    // OTHERS ********************************************************
    showErrors: function( result )
    {
        var context = this[0] ? this[0] : this;
        var text = this[1];
        context.containerErrors.show();
//        if( text )
//            context.containerErrors.html( interfaceTexts[result.responseText] + " " + text );
//        else if( interfaceTexts[result.responseText] )
//            context.containerErrors.html( interfaceTexts[result.responseText] );
        if( result.responseText )
            context.containerErrors.html( result.responseText );
        else
            context.containerErrors.html( result );
    },

    reduceLogin: function()
    {
        $( "#login" ).css( { zIndex:0 } );
        $( "#login_text" ).css( "visibility", "hidden" );
        $( "#login_bg" ).animate( {
            opacity: 1,
            height:'60px',
            width:'78px',
            zIndex:'0'
        }, 2000, function()
        {
        } );

        $( "#login_button" ).animate( {
            top:'16px',
            left: '20px'
        }, 2000, function()
        {
        } );
    },

    enlargeLogin: function()
    {
        $( "#login" ).css( { zIndex:1 } );
        $( "#login_bg" ).animate( {
            opacity: 0.45,
            height:'500px',
            width:'500px'
        }, 2000, function()
        {
            $( "#login_text" ).css( "visibility", "visible" );
        } );

        $( "#login_button" ).animate( {
            top:'82px',
            left: '155px'
        }, 2000, function()
        {
        } );
    },

    reduceCreditsOrMentions: function( div, div_bg, div_text, div_title )
    {
        div.css( { zIndex:0 } );
        div_text.css( "visibility", "hidden" );
        div.animate( {
            left: '+=500',
            top: '+=500'
        }, 2000, function()
        {
        } );
        div_bg.animate( {
            opacity: 1,
            height:'42px',
            width:'59px',
            zIndex:'0'
        }, 2000, function()
        {
            div_title.css( "visibility", "visible" );
        } );
    },

    enlargeCreditsOrMentions: function( div, div_bg, div_text, div_title, pageToLoad )
    {
        div_title.css( "visibility", "hidden" );
        div.css( { zIndex:1 } );
        div.animate( {
            left: '-=500',
            top: '-=500'
        }, 2000, function()
        {
        } );

        div_bg.animate( {
            opacity: 0.95,
            height:'500px',
            width:'500px'
        }, 2000, function()
        {
            div_text.css( "visibility", "visible" );
            div_text.load( pageToLoad );
        } );
    },

    animateMenuCircle: function()
    {
        jQuery.each( this.projectsArray, jQuery.proxy( function( i, logo )
        {
            $( "#" + logo.id ).animate( {
                top:logo.top,
                left:logo.left
            }, 5000, function()
            {
            } );
        }, this ) );
    },

    bindMenuCircle: function()
    {
        var gridimage;
        $( '.divLogo' ).mouseover(
                function()
                {
                    gridimage = $( this ).find( 'img' ); //Define target as a variable
                    gridimage.stop().animate( {width: 50, height:50}, 150 );
                } ).mouseout(
                jQuery.proxy( function( element )
                {
                    this.selectedLogo = element.currentTarget;
                    gridimage.stop().animate( {width: this.logoSize, height:this.logoSize}, 150 );
                }, this ) ).dblclick(
                jQuery.proxy( function()
                {
                    this.onClickLogo();
                }, this ) );
    },

    changeLeftTopSlide: function()
    {
        this.leftTopSlide.setTitle( '<spring:message code="title"/> : ' + this.selectedLogo.id );
        this.leftTopSlide.setContent(
                "<spring:message code="statistics.online"/> : 2006/05/08<BR/>" +
                        "<span class='text1'><spring:message code="statistics.since"/> : 2009/05/08<BR/><BR/></span>" +
                        "<spring:message code="statistics.user.registered"/> : 1500<BR/>" +
                        "<spring:message code="statistics.visit"/> : 150<BR/>" );
    },

    changeLeftMiddleSlide: function()
    {
        this.leftMiddleSlide.setContent( "<spring:message code="statistics.data.download"/> : 15001<BR/><spring:message code="statistics.data.download.size"/> : 50To<BR/>" );
    },

    changeLeftBottomSlide: function()
    {
        this.leftBottomSlide.setContent( "<spring:message code="statistics.duration.total"/> : 15001''<BR/><spring:message code="statistics.duration.average"/> : 50''<BR/>" );
    },

    changeRightSlide: function()
    {
        this.rightSlide.setTitle( '<spring:message code="label.actions"/>' );
        this.rightSlide.getDivContent().empty();
        new Button( {value:"<spring:message code="statistics.visit"/>", parent:this.rightSlide.getDivContent(), className: "positive action_button", onClick:jQuery.proxy( this.displayVisitEvolution, this )} );
        new Button( {value:"<spring:message code="statistics.user.registered"/>", parent:this.rightSlide.getDivContent(), className: "positive action_button", onClick:jQuery.proxy( this.displayRegisteredUserEvolution, this )} );
        new Button( {value:"<spring:message code="statistics.user.connected"/>", parent:this.rightSlide.getDivContent(), className: "positive action_button", onClick:jQuery.proxy( this.displayConnectedUserEvolution, this )} );
        new Button( {value:"<spring:message code="statistics.data.download"/>", parent:this.rightSlide.getDivContent(), className: "positive action_button", onClick:jQuery.proxy( this.displayDownloadEvolution, this )} );
        new Button( {value:"<spring:message code="statistics.map.distribution"/>", parent:this.rightSlide.getDivContent(), className: "positive action_button", onClick:jQuery.proxy( this.displayMapDistribution, this )} );
        new Button( {value:"<spring:message code="label.export"/>", parent:this.rightSlide.getDivContent(), className: "blue export_button", onClick:jQuery.proxy( this.onClickExport, this )} );
    },

    changeMiddleSlide: function( titleEvolution, titleDistribution )
    {
        if( this.isSelectedLogoEther )
            this.middleSlide.setTitle( '<spring:message code="statistics.evolution.distribution"/> : ' + this.selectedLogo.id );
        else
            this.middleSlide.setTitle( '<spring:message code="statistics.evolution"/> : ' + this.selectedLogo.id );
        this.middleSlide.getDivContent().empty();

        var linechart = $( document.createElement( "div" ) );
        linechart.addClass( "ui-widget ui-widget-content ui-corner-all statisticsEther" );
        linechart.attr( {id:"wijlinechart"} );
        this.middleSlide.getDivContent().append( linechart );

        var donut = $( document.createElement( "div" ) );
        donut.addClass( "ui-widget ui-widget-content ui-corner-all statisticsEther" );
        donut.attr( {id:"wijpiechart"} );
        this.middleSlide.getDivContent().append( donut );

        this.createLinechart( titleEvolution );
        if( this.isSelectedLogoEther )
            this.createDonut( titleDistribution );
    },

    changeMiddleSlideForMap: function()
    {
        this.middleSlide.setTitle( '<spring:message code="statistics.map.distribution"/> : ' + this.selectedLogo.id );
        this.middleSlide.getDivContent().empty();
    },


    // STATISTICS ********************************************************
    createDonut: function( title )
    {
        $( "#wijpiechart" ).wijpiechart( {
            height: 210,
            width: 400,
            radius: 140,
            legend: { visible: true },
            hint: {
                content: function ()
                {
                    return this.data.label + " : " + Globalize.format( this.value / this.total, "p2" );
                }
            },
            header: {
                text: title
            },
            seriesList: [
                {
                    label: "MacBook Pro",
                    legendEntry: true,
                    data: 46.78,
                    offset: 0
                },
                {
                    label: "iMac",
                    legendEntry: true,
                    data: 23.18,
                    offset: 0
                },
                {
                    label: "MacBook",
                    legendEntry: true,
                    data: 20.25,
                    offset: 0
                },
                {
                    label: "Mac Pro",
                    legendEntry: true,
                    data: 5.41,
                    offset: 0
                },
                {
                    label: "Mac mini",
                    legendEntry: true,
                    data: 3.44,
                    offset: 0
                }
            ],
            seriesStyles: [
                {
                    fill: "180-rgb(195,255,0)-rgb(175,229,0)", stroke: "rgb(175,229,0)", "stroke-width": 1.5
                },
                {
                    fill: "90-rgb(142,222,67)-rgb(127,199,60)", stroke: "rgb(127,199,60)", "stroke-width": 1.5
                },
                {
                    fill: "90-rgb(106,171,167)-rgb(95,153,150)", stroke: "rgb(95,153,150)", "stroke-width": 1.5
                },
                {
                    fill: "90-rgb(70,106,133)-rgb(62,95,119)", stroke: "rgb(62,95,119)", "stroke-width": 1.5
                },
                {
                    fill: "90-rgb(166,166,166)-rgb(149,149,149)", stroke: "rgb(149,149,149)", "stroke-width": 1.5
                }
            ]
        } );
    },

    createLinechart: function( title )
    {
        $( "#wijlinechart" ).wijlinechart( {
            height: 200,
            width: 400,
            axis: {
                y: {
                    origin: 0
                }
            },
            showChartLabels: false,
            header: {
                text: title
            },
            hint: {
                content: function ()
                {
                    return this.data.lineSeries.label + '\n' + this.x + '\n' + this.y + '';
                },
                contentStyle: { "font-size": 10 },
                offsetY: -10
            },
            legend: {
                visible: false
            },
            seriesList: [
                {
                    label: "",
                    legendEntry: true,
                    data: {
                        x: this.xArray,
                        y: this.yArray
                    },
                    markers: {
                        visible: true,
                        type: "circle"
                    }
                }
            ]
        } );
    },

    displayVisitEvolution: function()
    {
        this.changeMiddleSlide( '<spring:message code="statistics.evolution.visit"/>', '<spring:message code="statistics.distribution.visit"/>' );
    },

    displayRegisteredUserEvolution: function()
    {
        this.changeMiddleSlide( '<spring:message code="statistics.evolution.user.registered"/>', '<spring:message code="statistics.distribution.user.registered"/>' );
    },

    displayConnectedUserEvolution: function()
    {
        this.changeMiddleSlide( '<spring:message code="statistics.evolution.user.connected"/>', '<spring:message code="statistics.distribution.user.connected"/>' );
    },

    displayDownloadEvolution: function()
    {
        this.changeMiddleSlide( '<spring:message code="statistics.evolution.download"/>', '<spring:message code="statistics.distribution.download"/>' );
    },

    displayMapDistribution: function()
    {
        this.changeMiddleSlideForMap();
    }

} );

</script>
